	org $1001-2
	dw  $1001
	
	dw nextln,0
	db $9E,"4109",0
nextln	db 0,0

; window
win_width		= $D0
win_height		= $D1
win_color		= $D2
yloop			= $D3

; random
rand			= $D4	; 32 bit

; keyboard
keyb_ptr		= $D8	; 16 bit
keyb_lastkey		= $DA
keyb_repeatcnt		= $DB
keyb_shift		= $DC
keyb_repeat_init	= 20	; constant
keyb_repeat		= 4	; constant

col_ptr			= $E0
chr_ptr 		= $E2

right_side		= $E4	; $00 = right side, $FF left (piece selection)
current_left_index	= $E5
current_board_pos	= $E6
current_piece		= $E7

SCORE_POS = $0F4F

EMPTY_COLOR = $51

EMPTY_CHR1 = $70
EMPTY_CHR2 = $5D
EMPTY_CHR3 = $40
EMPTY_CHR4 = $7D

BLOCK_CHR1 = $A0
BLOCK_CHR2 = $EA
BLOCK_CHR3 = $EF
BLOCK_CHR4 = $FA

SELECTION_CHR1 = $4F
SELECTION_CHR2 = $50
SELECTION_CHR3 = $4C
SELECTION_CHR4 = $7A

board = $2000

DrawWindow	macro	xp, yp, width, height, color
	lda #($0C00+xp+yp*40) & 255
	sta chr_ptr
	lda #($0C00+xp+yp*40) >> 8
	sta chr_ptr+1
	lda #width
	sta win_width
	lda #height
	sta win_height
	lda #color
	sta win_color
	jsr draw_border
endm

CopyChars	macro source_addr, dest_addr, width, height, color
	lda #dest_addr & 255
	sta chr_ptr
	sta col_ptr
	lda #dest_addr >> 8
	sta chr_ptr+1
	and #$FB
	sta col_ptr+1
	;
	ldx #0
	ldy #0
	lda source_addr,x
	sta (chr_ptr),y
	lda #color
	sta (col_ptr),y
	inx
	iny
	cpy #width
	bne *-13
	;
	jsr chr_ptr_add_40
	cpx #width*height
	bne *-22
endm

start
	sei
	sta $ff3f
	;
	ldx #$FF
	lda $FF07
	and #$40
	beq sp
	ldx #$F8
sp	jsr sync_x
	;
	lda #$61
	sta $FF19
	sta $FF15
	lda #$0B
	sta $FF06
	;
	; ---
	;
	jsr InitRandom
	;
	; ---
	;
title_screen
	jsr screen_off
	;
	jsr draw_wallpaper
	;
	DrawWindow 4, 6, 30, 12, $41
	CopyChars logo_text, $0D27, 9, 5, $21
	CopyChars title_text, $0E35, 29, 4, $31
	;
	jsr screen_on
	;
	jsr wait_for_no_keypress
	;
	lda #menu_key_table & 255
	ldx #menu_key_table >> 8
	jmp keyboard
	;
	; ---
	;
newgame	jsr InitRandom
	jsr screen_off
	jsr draw_wallpaper
	DrawWindow 6, 1, 27, 21, $41
	;
	; ---
	;
	ldx #$00
lp1b	lda #$00
	sta board,x				; clear (initialize) board
	txa
	cmp #$A0
	bcs lp1a
	and #$0F
	cmp #$0A
	bcs lp1a
	jsr draw_empty				; and draw it
lp1a	inx
	bne lp1b
	;
	ldx #$04
	lda #$00
lp2	sta score,x				; reset score
	dex
	bpl lp2
	;
	; ---
	;
	jsr generate_3
	;
	; ---
	;
	lda #$FF				; mark that we are on the LEFT side
	sta right_side
	lda #$00
	sta current_left_index			; reset left pos...
	lda #$00
	sta current_board_pos			; and right pos
	jsr draw_selection
	;
	; ---
	;
	jsr screen_on
game_loop
	lda #key_table & 255
	ldx #key_table >> 8
	jmp keyboard
	
sync_frame
	ldx #$CB
sync_x	cpx $FF1D
	bne *-3
	rts
	
screen_off
	jsr sync_frame
	lda #$0B
	sta $FF06
	rts
	
screen_on
	jsr sync_frame
	lda #$1B
	sta $FF06
	rts

wait_for_no_keypress
	lda #$00
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wait_for_no_keypress
	rts
	
draw_wallpaper
	jsr GetRandom				; random number between 0-7
	and #$07
	;
	sta dw_1+1
	asl a
	clc
dw_1	adc #$00
	clc
	adc #(wallpaper & 255)
	sta dw_3+1 
	;
	lda #$00
	sta chr_ptr
	sta col_ptr
	lda #$08
	sta col_ptr+1
	lda #$0C
	sta chr_ptr+1
dw_2	ldy #$02
dw_3	lda wallpaper+0,y			; draw wallpaper
	sta (chr_ptr),y
	lda #$51				; wallpaper color
	sta (col_ptr),y
	dey
	bpl dw_3
	;
	lda chr_ptr
	clc
	adc #$03
	sta chr_ptr
	sta col_ptr
	bcc *+6
	inc chr_ptr+1
	inc col_ptr+1
	;
	lda chr_ptr+1
	cmp #$0F
	bne dw_2
	lda chr_ptr
	cmp #$E8
	bcc dw_2
	rts
	
generate_3
	ldx #0
	jsr erase_small
	ldx #1
	jsr erase_small
	ldx #2
	jsr erase_small
	;
	jsr GetRandomPiece
	sta current_pieces+0
	ldx #$00
	jsr draw_small
	;
	jsr GetRandomPiece
	sta current_pieces+1
	ldx #$01
	jsr draw_small
	;
	jsr GetRandomPiece
	sta current_pieces+2
	ldx #$02
	jsr draw_small
	rts
	
	;
	; ------------------------------------------
	;
GetRandomPiece
	jsr GetRandom
	tay
	lda piece_type_index,y
	sta grp_1+1
	;
	tay
	lda piece_type_rotation_bits,y
	sta grp_2+1
	;
	txa
grp_2	and #$00
	clc
grp_1	adc #$00
	rts
	
	;
	; draw border
	;
draw_border
	lda chr_ptr
	sta col_ptr
	lda chr_ptr+1
	and #$FB
	sta col_ptr+1
	;
	ldy #$00				; top border
	lda border_chars
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	iny
	;
	ldx win_width
	dex
	dex
db1	lda border_chars+1
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	iny
	dex
	bpl db1
	;
	lda border_chars+2
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	;
	jsr chr_ptr_add_40
	;
	ldx win_height
	dex
	dex
	stx yloop
	;
	; ---
	;
db3	ldy #$00				; middle lines
	lda border_chars+3
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	iny
	;
	ldx win_width
	dex
	dex
db2	lda border_chars+4
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	iny
	dex
	bpl db2
	;
	lda border_chars+5
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	;
	iny
	lda (col_ptr),y
	sec
	sbc #$10
	sta (col_ptr),y 
	;
	jsr chr_ptr_add_40
	;
	dec yloop
	bpl db3
	;
	; ---
	;
	ldy #$00				; bottom line
	lda border_chars+6
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	iny
	;
	ldx win_width
	dex
	dex
db4	lda border_chars+7
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	iny
	dex
	bpl db4
	;
	lda border_chars+8
	sta (chr_ptr),y
	lda win_color
	sta (col_ptr),y
	;
	iny
	lda (col_ptr),y
	sec
	sbc #$10
	sta (col_ptr),y
	;
	jsr chr_ptr_add_40
	;
	; ---
	;
	ldy #$01
	ldx win_width
db5	lda (col_ptr),y
	sec
	sbc #$10
	sta (col_ptr),y
	iny
	dex
	bpl db5
	;
	rts
	
chr_ptr_add_40
	lda #40
chr_ptr_add
	clc
	adc chr_ptr
	sta chr_ptr
	sta col_ptr
	bcc *+6
	inc chr_ptr+1
	inc col_ptr+1
	rts
	
border_chars
	db $4F,$77,$50
	db $65,$20,$6A
	db $4C,$6F,$7A
	;db $70,$40,$6E
	;db $5D,$20,$5D
	;db $6D,$40,$7D
	
	;
	; -----------------------------
	;

	;
	; X = index (0-2)
	;
erase_small
	lda small_pos_lo,x
	sta chr_ptr
	lda small_pos_hi,x
	sta chr_ptr+1
	;
	ldy #$00
es_2	ldx #$04				; width = 5
	lda #$20
es_1	sta (chr_ptr),y				; erase with spaces
	iny
	dex
	bpl es_1
	;
	tya
	clc
	adc #35
	tay
	cpy #200				; stop at 5*5
	bne es_2
	;
	rts
	
	;
	; X = index (0-2)
	; A = piece
	;
draw_small
	tay
	;
	lda small_pos_lo,x
	sta col_ptr
	sta chr_ptr
	lda small_pos_hi,x
	sta chr_ptr+1
	and #$FB
	sta col_ptr+1
	;
	lda piece_colors,y
	sta ds_2+1
	;
	lda pieces_small,y
	tax
ds_3	lda pieces_small,x
	cmp #$FF
	beq ds_1
	;
	tay
ds_2	lda #$00
	sta (col_ptr),y
	lda #$FA
	sta (chr_ptr),y
	inx
	bne ds_3
	;
ds_1	rts

get_selection_coords
	ldy current_left_index
	lda small_pos_lo,y
	sta col_ptr
	sta chr_ptr
	lda small_pos_hi,y
	sta chr_ptr+1
	and #$FB
	sta col_ptr+1
	rts

erase_selection
	jsr get_selection_coords
	lda #$20
	ldy #0
	sta (chr_ptr),y
	ldy #4
	sta (chr_ptr),y
	ldy #160
	sta (chr_ptr),y
	ldy #164
	sta (chr_ptr),y
	rts
	
draw_selection
	jsr get_selection_coords
	lda #SELECTION_CHR1
	ldy #0
	sta (chr_ptr),y
	lda #SELECTION_CHR2
	ldy #4
	sta (chr_ptr),y
	lda #SELECTION_CHR3
	ldy #160
	sta (chr_ptr),y
	lda #SELECTION_CHR4
	ldy #164
	sta (chr_ptr),y
	rts
	
	;
	; X = coordinate index
	;
draw_empty
	stx de_sx+1
	;
	jsr get_coord
	;
	ldx #EMPTY_COLOR
	ldy #0
	lda #EMPTY_CHR1
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	iny
	lda #EMPTY_CHR2
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	;
	ldy #40
	lda #EMPTY_CHR3
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	iny
	lda #EMPTY_CHR4
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	;
de_sx	ldx #$00
	rts
	
 	;
	; X = coordinate index
	; A = piece
	;
put_piece
	stx pp_2+1
	tay
	lda piece_colors,y
	sta pp_4+1
	lda pieces_big,y
	tay
pp_3	lda pieces_big,y
	bmi pp_1
	;
	clc
pp_2	adc #$00
	tax
pp_4	lda #$00
	sta board,x
	iny
	bne pp_3
	;
pp_1	rts

erase_current
	ldy current_piece
	lda pieces_big,y
	tay
ec_3	lda pieces_big,y
	bmi ec_1
	;
	sty ec_sy+1
	clc
	adc current_board_pos
	tax
	lda board,x
	bne ec_2
	;
	jsr draw_empty
	jmp ec_sy
	;
ec_2	jsr draw_block
ec_sy	ldy #$00
	iny
	bne ec_3
	;
ec_1	rts

draw_current
	ldx current_board_pos
	lda current_piece
	;
	stx dc_2+1
	tay
	lda piece_colors,y
	sta dc_col+1
	lda pieces_big,y
	tay
dc_3	lda pieces_big,y
	bmi dc_1
	;
	clc
dc_2	adc #$00
	tax
	lda board,x				; is this blocked by something on the board?
	beq dc_col
	;
	lda #$00				; if so, use black color
	db $2C
dc_col	lda #$00
	sty dc_sy+1
	jsr draw_block2
dc_sy	ldy #$00
	iny
	bne dc_3
	;
dc_1	rts

	;
	; X = coordinate index
	; Y = piece
	; A = color
	;
draw_piece_color
	stx dp_2+1
	sta dp_col+1
	jmp dp_4
	;
	; (no params)
	;
draw_current_piece
	ldx current_board_pos
	ldy current_piece
 	;
	stx dp_2+1
	lda piece_colors,y
	sta dp_col+1
	;
dp_4	lda pieces_big,y
	tay
dp_3	lda pieces_big,y
	bmi dp_1
	;
	clc
dp_2	adc #$00
	tax
dp_col	lda #$00
	sty dp_sy+1
	jsr draw_block
dp_sy	ldy #$00
	iny
	bne dp_3
	;
dp_1	rts
	
	;
	; A = piece
	; RETURN: carry clear = fits (somewhere)
	;         carry set   = does not fit (anywhere)
	;         if fits, [cpfa_2+1] will contain a valid board index
	;
can_piece_fit_anywhere
	sta cpfa_1+1				; save A for later
	;
	ldx #$00				; loop through the entire board
cpfa_4	stx cpfa_2+1
cpfa_1	lda #$00
	jsr does_piece_fit
	bcc cpfa_3				; yep, fits, we're done
cpfa_2	ldx #$00
	inx
	txa
	and #$0F
	cmp #$0A
	bcc cpfa_4
	txa
	clc
	adc #$06
	tax
	cpx #$A0
	bne cpfa_4
	;
	sec					; did not find any free places	
	rts
	;	
cpfa_3	clc
	rts

	;
	; X = coordinate index
	; A = piece
	; RETURN: carry clear = fits
	;         carry set   = does not fit
	;
does_piece_fit
	stx dpf_3+1
	tay
	lda pieces_big,y
	tay
dpf_1	lda pieces_big,y
	bmi dpf_2				; we got to the end, it fits!
	;
	clc
dpf_3	adc #$00
	tax
	cmp #$A0				; out of bounds down?
	bcs dpf_4				; exit with FALSE
	;
	and #$0F
	cmp #$0A				; out of bounds right?
	bcs dpf_4				; exit with FALSE
	;
	lda board,x
	bne dpf_4				; non-zero, does not fit
	;
	iny
	bne dpf_1
	;
dpf_2	clc
	rts
dpf_4	sec
	rts

	;
	; X = coordinate index
	; A = color
	;
draw_block
	stx db_sx+1
	sta db_c+1
	;
	jsr get_coord
	;
db_c	ldx #$00
	ldy #0
	lda #BLOCK_CHR1
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	iny
	lda #BLOCK_CHR2
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	;
	ldy #40
	lda #BLOCK_CHR3
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	iny
	lda #BLOCK_CHR4
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	;
db_sx	ldx #$00
	rts
	
	;
	; X = coordinate index
	; A = color
	;
draw_block2
	stx db2_sx+1
	sta db2_c+1
	;
	jsr get_coord
	;
db2_c	ldx #$00
	ldy #0
	lda #BLOCK_CHR4
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	iny
	lda #BLOCK_CHR4
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	;
	ldy #40
	lda #BLOCK_CHR4
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	iny
	lda #BLOCK_CHR4
	sta (chr_ptr),y
	txa
	sta (col_ptr),y
	;
db2_sx	ldx #$00
	rts
	
get_coord
	lda board_positions_lo,x
	sta col_ptr
	sta chr_ptr
	;
	lda board_positions_hi,x
	clc
	adc #$08
	sta col_ptr+1
	ora #$04
	sta chr_ptr+1
	rts
	
	;
	; ---
	;
ask_quit
	ldx #$04
aq_1	lda quit_text,x
	sta SCORE_POS-40,x
	lda quit_text+5,x
	sta SCORE_POS,x
	;
	dex
	bpl aq_1
	;
	lda #quit_key_table & 255
	ldx #quit_key_table >> 8
	jmp keyboard
	
quit_no
	ldx #$04
	lda #$20
qn_1	sta SCORE_POS-40,x
	sta SCORE_POS,x
	dex
	bpl qn_1
	jsr display_score
	jmp game_loop
	
	;
	; ---
	;
put_back_current
	lda right_side				; on the left side, this does nothing
	bne pbc_1
	;
	jsr erase_current			; move piece back out to left side
	lda #$FF
	sta right_side
	jsr draw_selection
	ldx current_left_index
	lda current_pieces,x
	jsr draw_small
pbc_1	jmp game_loop
	
	;
	; ---
	;
try_place_current
	lda right_side				; on left side, this key does nothing
	bne tpc_1
	;
	ldx current_board_pos			; check if current piece can fit
	lda current_piece
	jsr does_piece_fit
	bcc tpc_2				; yes, this piece can be placed
	;
tpc_1	jmp game_loop
	;
	; *** Place piece on board
	;
tpc_2	ldx current_board_pos			; yes, place it on the board
	lda current_piece
	jsr put_piece
	;
	jsr draw_current_piece
	;
	ldx current_piece
	lda piece_score,x
	jsr add_score
	jsr display_score
	;
	; mark the current piece "done"
	;
	ldx current_left_index
	lda #$FF
	sta current_pieces,x
	;
	; *** find any lines disappearing
	;
	lda #1					; reset line score (first complete line = 10 points)
	sta add_score_x10+1
	;
	ldx #$00
tpc_a	txa
	pha					; save X in stack
	lda #$01				; A=1 (move index right)
	jsr check_line_full			; check rows
	bcc tpc_b
	;
	jsr add_score_x10
	jsr display_score
	;
tpc_b	pla
	clc
	adc #$10
	tax
	cpx #$A0
	bne tpc_a
	;
	ldx #$00
tpc_c	txa
	pha					; save X in stack
	lda #$10				; A=$10 (move index down)
	jsr check_line_full			; check columns
	bcc tpc_d
	;
	jsr add_score_x10
	jsr display_score
	;
tpc_d	pla
	tax
	inx
	cpx #10
	bne tpc_c
	;
	; --- clear board
	;
	;dec $FF19
	ldx #$00
tpc_f	lda board,x
	cmp #$FF
	bne tpc_e
	;
	lda #$00
	sta board,x
	jsr draw_empty
	;
tpc_e	inx
	bne tpc_f
	;inc $FF19
	;
	; find the next piece on the left
	;
	ldx #$00
tpc_3	lda current_pieces,x
	bpl tpc_4
	inx
	cpx #$03
	bne tpc_3
	;
	; no more pieces on the left, generate 3 more
	;
	jsr generate_3
	ldx #$00
	;
tpc_4	stx current_left_index
	lda #$FF
	sta right_side
	jsr draw_selection
	;
	; *** check game over
	;
	lda current_pieces
	bmi tpc_5
	;
	jsr can_piece_fit_anywhere
	bcc tpc_7
	;
tpc_5	lda current_pieces+1
	bmi tpc_6
	;
	jsr can_piece_fit_anywhere
	bcc tpc_7
	;
tpc_6	lda current_pieces+2
	bmi game_over
	;
	jsr can_piece_fit_anywhere
	bcs game_over
	;
tpc_7	jmp game_loop
	;
	; *** Game over
	;
game_over
	jsr erase_selection
	;
	DrawWindow 15, 4, 14, 14, $41
	;
	lda #$01
	sta chr_ptr
	sta col_ptr
	lda #$09
	sta col_ptr+1
	ora #$04
	sta chr_ptr+1
	;
	ldx #0
go_1	ldy #0
go_2	lda game_over_text,x
	sta (chr_ptr),y
	lda #$21
	sta (col_ptr),y
	inx
	iny
	cpy #11
	bne go_2
	;
	jsr chr_ptr_add_40
	cpx #11*11
	bne go_1
	;
	ldx #4
go_3	lda SCORE_POS,x
	sta $0EBC,x
	dex
	bpl go_3
	;
	; ---
	;
	jsr wait_for_no_keypress
	;
	lda #game_over_key_table & 255
	ldx #game_over_key_table >> 8
	jmp keyboard
	
	;
	; X = starting position index
	; A = value to add ($1 = horizontal, $10 = vertical)
	;
check_line_full
	stx clf_3+1
	sta clf_2+1
	;
	ldy #10
clf_1	lda board,x				; check board
	beq clf_5				; 0 = empty, exit loop
	;
	txa
	clc
clf_2	adc #$00				; move position index ahead
	tax
	dey
	bne clf_1
	;
	; --- line is full, do another loop to mark pieces as "removed"
	;
	ldy #10
clf_3	ldx #$00
clf_4	lda #$FF				; mark it ready for removal
	sta board,x				; cannot be set to zero, that avoid disallow "crosses" (one row & column disappearing at the same time)
	;
	txa
	clc
	adc clf_2+1
	tax
	dey
	bne clf_4
	;
	sec
	rts	

clf_5	clc
	rts
	
	;
	; Displays the current score (no leading zeros)
	;
display_score
	ldx #0
dsc_1	lda score,x
	bne dsc_2
	;
	lda #$20
	sta SCORE_POS,x
	inx
	cpx #5
	bne dsc_1
	rts
	;
dsc_2	lda score,x
	ora #$30
	sta SCORE_POS,x
	inx
	cpx #5
	bne dsc_2
	rts

	;
	; This adds 10 to the score,
	; and increases the value added by 10.
	; (Score for each completed line is 10, 20, 30, etc.)
	;
add_score_x10
	lda #1
	ldx #3
	jsr as_1
	inc add_score_x10+1
	rts
	 
	;
	; A = score to add (maximum 9)
	;
add_score
	ldx #4
as_1	clc
	adc score,x
	cmp #10
	bcc as_2				; no overflow
	;
	cpx #$00
	beq ScoreOver99999
	inc score-1,x
	sec
	sbc #$0A
as_2	sta score,x
	lda #$00
	dex
	bpl as_1
	;
	rts
	
ScoreOver99999
	lda #$09
	db $2C
clear_score
	lda #$00	
	ldx #4
cs_1	sta score,x
	dex
	bpl cs_1
	;
	rts
	
	;
	; ---
	;
no_move
	jmp game_loop
	
MoveUp
	lda right_side
	beq mu_r
	;
	lda current_left_index
	beq no_move
	;
	lda #$FF				; move up
	jmp move_current_l
	;
mu_r	lda current_board_pos
	cmp #$10
	bcc no_move
	;
	sec
	sbc #$10				; move up one line
	jmp move_current_r
	
MoveDown
	lda right_side
	beq md_r
	;
	lda current_left_index
	cmp #$02
	beq no_move
	;
	lda #$01				; move down
	jmp move_current_l
	;
md_r	ldx current_piece
	lda current_board_pos
	cmp piece_down_limit,x
	bcs no_move
	;
	clc
	adc #$10				; move down one line
	jmp move_current_r

MoveLeft
	lda right_side
	bne no_move				; when already on the left side, can't move left
	;
	lda current_board_pos
	and #$0F
	bne ml_1				; non-zero? then we can move left
	;
	jmp put_back_current
	;
ml_1	lda current_board_pos
	sec
	sbc #$01				; move left one block
	jmp move_current_r
	
MoveRight
	lda right_side
	beq mr_r
	;
	ldx current_left_index
	lda current_pieces,x			; if current piece is $FF (negative), nothing to move
	bmi mcr_2
	;
	jsr erase_small
	ldx current_left_index
	lda current_pieces,x
	sta current_piece
	tay
	;
	cpx #$02
	beq mr_2
	cpx #$01
	beq mr_1
	lda piece_starting_pos_1,y
	jmp mr_p
mr_1	lda piece_starting_pos_2,y
	jmp mr_p
mr_2	lda piece_starting_pos_3,y
mr_p	sta current_board_pos
	;
	lda #$00
	sta right_side
	;
	jsr erase_selection
	jsr draw_current
	jmp game_loop
	;
mr_r	ldx current_piece
	lda current_board_pos
	and #$0F
	cmp piece_right_limit,x
	bcs mcr_2				; cannot move right
	;
	lda current_board_pos
	clc
	adc #$01				; move right one block
	;	
move_current_r
	;dec $FF19				; move the current piece on the board (right side)
	sta mcr_1+1
	jsr erase_current
mcr_1	lda #$00
	sta current_board_pos
	jsr draw_current
	;inc $FF19
mcr_2	jmp game_loop
	
move_current_l
	sta mcl_1+1				; move selection on the left side
	jsr erase_selection
	lda current_left_index
	clc
mcl_1	adc #$00
	sta current_left_index
	jsr draw_selection
	jmp game_loop
	
MoveHome
	lda right_side
	beq mh_r
	;
	ldx current_left_index
	beq mh_1
	;
	lda #$00
	jmp move_current_l
	;
mh_r	lda current_board_pos
	beq mh_1
	;
	lda #$00
	jmp move_current_r
	;
mh_1	jmp game_loop

show_help
	lda right_side
	beq sh_1
	;
	ldx current_left_index
	lda current_pieces,x
	bmi sh_x				; no piece, do nothing
	;
	jsr erase_selection
	ldx current_left_index
	lda current_pieces,x
	sta current_piece			; (necessary for erase)
	jmp sh_2
	;
sh_1	jsr erase_current
	ldx current_board_pos
	lda current_piece
	;
sh_2	stx sh_pos+1
	sta sh_pc+1
	jsr can_piece_fit_anywhere
	bcs sh_no
	;
	ldx #$00
sh_4	stx sh_sx+1
	;
	ldx #$D0
	ldy #$07
sh_5	jsr sync_x
	dex
	dey
	bpl sh_5
	;
	lda sh_sx+1
	and #$01
	tax
	lda flash_colors,x
	ldx cpfa_2+1
sh_pc	ldy #$00
	jsr draw_piece_color
sh_sx	ldx #$00
	inx
	cpx #10
	bne sh_4
	;
	; --- erase "help"
	;
	lda cpfa_2+1
	sta current_board_pos
	jsr erase_current
sh_pos	lda #$00
	sta current_board_pos
	;
sh_no	lda right_side
	beq sh_3
	;
	jsr draw_selection
	jmp sh_x
	;
sh_3	jsr draw_current
	;
sh_x	jmp game_loop
	
quit
	jsr wait_for_no_keypress
	sta $FF3E
	cli
	jsr $FF4F
	db $1B,"N",$92,"BYE!",0
	jmp $8003
	
	include "key_constants.asm"
	include "keyboard.asm"
	include "random.asm"
	
menu_key_table
	dw null
	;
	dw $8002, newgame
	dw $4004, newgame
	dw KEY_SPACE, newgame
	dw KEY_RETURN, newgame
	dw KEY_ESC, quit
	dw KEY_RUN_STOP, quit
	;
	dw 0
	
game_over_key_table
	dw null
	;
	dw $8002, title_screen
	dw $4004, title_screen
	dw KEY_SPACE, title_screen
	dw KEY_RETURN, title_screen
	dw KEY_ESC, title_screen
	dw KEY_RUN_STOP, title_screen
	;
	dw 0
	
quit_key_table
	dw null
	;
	dw KEY_Y, title_screen
	dw KEY_N, quit_no
	;
	dw 0
	
key_table
	dw null
	;
	dw $0102, MoveUp			; Joystick 1
	dw $0202, MoveDown
	dw $0402, MoveLeft
	dw $0802, MoveRight
	dw $8002, try_place_current
	;
	dw $0104, MoveUp			; Joystick 2
	dw $0204, MoveDown
	dw $0404, MoveLeft
	dw $0804, MoveRight
	dw $4004, try_place_current  
	;
	dw KEY_CURSOR_RIGHT, MoveRight		; cursor keys
	dw KEY_CURSOR_LEFT, MoveLeft
	dw KEY_CURSOR_UP, MoveUp
	dw KEY_CURSOR_DOWN, MoveDown
	;
	dw KEY_Z, MoveLeft			; alternate keys
	dw KEY_X, MoveRight
	dw KEY_SEMICOLON, MoveUp
	dw KEY_SLASH, MoveDown
	;
	dw KEY_CLEAR_HOME, MoveHome
	;
	dw KEY_SPACE, try_place_current
	dw KEY_RETURN, try_place_current
	;
	dw KEY_HELP, show_help
	dw KEY_H, show_help
	;
	dw KEY_ESC, put_back_current
	dw KEY_RUN_STOP, ask_quit
	;
	dw 0
	
null
	rts
	
logo_text
	db $F7,$CF,$F7,$D0,$F7,$CF,$F7,$D0,$D0
	db $E5,$E5,$20,$EA,$E5,$E5,$20,$EA,$EA
	db $E5,$E5,$20,$EA,$E5,$E5,$20,$EA,$EA
	db $E5,$E5,$20,$EA,$E5,$E5,$20,$EA,$EA
	db $E5,$E5,$F7,$EA,$E5,$E5,$F7,$EA,$D0

title_text	
	db $17,$12,$09,$14,$14,$05,$0E,$20,$02,$19,$20,$03,$13,$01,$02,$0F,$20,$0F,$06,$20,$0C,$0F,$04,$2C,$20,$32,$30,$31,$36
	db $06,$09,$14,$20,$14,$08,$05,$20,$10,$09,$05,$03,$05,$13,$20,$0F,$0E,$14,$0F,$20,$14,$08,$05,$20,$02,$0F,$01,$12,$04
	db $20,$20,$03,$0F,$0D,$10,$0C,$05,$14,$05,$20,$12,$0F,$17,$13,$20,$01,$0E,$04,$20,$03,$0F,$0C,$15,$0D,$0E,$13,$20,$20
	db $20,$20,$20,$20,$20,$20,$20,$14,$0F,$20,$03,$0C,$05,$01,$12,$20,$02,$0C,$0F,$03,$0B,$13,$20,$20,$20,$20,$20,$20,$20
	
game_over_text	
	db $4E,$77,$60,$4E,$4D,$6A,$4D,$4E,$74,$4F,$77
	db $65,$6F,$20,$65,$6A,$6A,$20,$20,$74,$4C,$20
	db $65,$6A,$20,$4F,$50,$6A,$20,$20,$74,$74,$20
	db $4D,$7A,$20,$74,$6A,$6A,$20,$20,$74,$4C,$6F
	db $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	db $4E,$4D,$20,$74,$6A,$6A,$77,$77,$6A,$77,$4D
	db $65,$6A,$20,$65,$6A,$6A,$64,$20,$6A,$64,$4E
	db $65,$6A,$20,$65,$6A,$6A,$63,$20,$6A,$63,$4D
	db $4D,$4E,$20,$4D,$4E,$6A,$6F,$6F,$6A,$20,$6A
	db $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	db $06,$09,$0E,$01,$0C,$20,$13,$03,$0F,$12,$05
	
quit_text
	db $11,$15,$09,$14,$3F,$28,$19,$2F,$0E,$29
	
score
	db 0,0,0,0,0
	
current_pieces
	db 0,0,0
	
flash_colors
	db $25,$71
	
	;align 32
wallpaper
	db $56,$CB,$D5
	db $D5,$CE,$CB
	db $CF,$CD,$FA
	db $CF,$E5,$F7
	db $CF,$F7,$F7
	db $D6,$DB,$D6
	db $5F,$DF,$DF
	db $5F,$EA,$DF
	
small_pos_lo
	db ($0C00+7+ 3*40) & 255
	db ($0C00+7+ 9*40) & 255
	db ($0C00+7+15*40) & 255
	
small_pos_hi
	db ($0C00+7+ 3*40) >> 8
	db ($0C00+7+ 9*40) >> 8
	db ($0C00+7+15*40) >> 8

	align 256
board_positions_lo
	db (93 + 0*2 + 0*80) & 255
	db (93 + 1*2 + 0*80) & 255
	db (93 + 2*2 + 0*80) & 255
	db (93 + 3*2 + 0*80) & 255
	db (93 + 4*2 + 0*80) & 255
	db (93 + 5*2 + 0*80) & 255
	db (93 + 6*2 + 0*80) & 255
	db (93 + 7*2 + 0*80) & 255
	db (93 + 8*2 + 0*80) & 255
	db (93 + 9*2 + 0*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 1*80) & 255
	db (93 + 1*2 + 1*80) & 255
	db (93 + 2*2 + 1*80) & 255
	db (93 + 3*2 + 1*80) & 255
	db (93 + 4*2 + 1*80) & 255
	db (93 + 5*2 + 1*80) & 255
	db (93 + 6*2 + 1*80) & 255
	db (93 + 7*2 + 1*80) & 255
	db (93 + 8*2 + 1*80) & 255
	db (93 + 9*2 + 1*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 2*80) & 255
	db (93 + 1*2 + 2*80) & 255
	db (93 + 2*2 + 2*80) & 255
	db (93 + 3*2 + 2*80) & 255
	db (93 + 4*2 + 2*80) & 255
	db (93 + 5*2 + 2*80) & 255
	db (93 + 6*2 + 2*80) & 255
	db (93 + 7*2 + 2*80) & 255
	db (93 + 8*2 + 2*80) & 255
	db (93 + 9*2 + 2*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 3*80) & 255
	db (93 + 1*2 + 3*80) & 255
	db (93 + 2*2 + 3*80) & 255
	db (93 + 3*2 + 3*80) & 255
	db (93 + 4*2 + 3*80) & 255
	db (93 + 5*2 + 3*80) & 255
	db (93 + 6*2 + 3*80) & 255
	db (93 + 7*2 + 3*80) & 255
	db (93 + 8*2 + 3*80) & 255
	db (93 + 9*2 + 3*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 4*80) & 255
	db (93 + 1*2 + 4*80) & 255
	db (93 + 2*2 + 4*80) & 255
	db (93 + 3*2 + 4*80) & 255
	db (93 + 4*2 + 4*80) & 255
	db (93 + 5*2 + 4*80) & 255
	db (93 + 6*2 + 4*80) & 255
	db (93 + 7*2 + 4*80) & 255
	db (93 + 8*2 + 4*80) & 255
	db (93 + 9*2 + 4*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 5*80) & 255
	db (93 + 1*2 + 5*80) & 255
	db (93 + 2*2 + 5*80) & 255
	db (93 + 3*2 + 5*80) & 255
	db (93 + 4*2 + 5*80) & 255
	db (93 + 5*2 + 5*80) & 255
	db (93 + 6*2 + 5*80) & 255
	db (93 + 7*2 + 5*80) & 255
	db (93 + 8*2 + 5*80) & 255
	db (93 + 9*2 + 5*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 6*80) & 255
	db (93 + 1*2 + 6*80) & 255
	db (93 + 2*2 + 6*80) & 255
	db (93 + 3*2 + 6*80) & 255
	db (93 + 4*2 + 6*80) & 255
	db (93 + 5*2 + 6*80) & 255
	db (93 + 6*2 + 6*80) & 255
	db (93 + 7*2 + 6*80) & 255
	db (93 + 8*2 + 6*80) & 255
	db (93 + 9*2 + 6*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 7*80) & 255
	db (93 + 1*2 + 7*80) & 255
	db (93 + 2*2 + 7*80) & 255
	db (93 + 3*2 + 7*80) & 255
	db (93 + 4*2 + 7*80) & 255
	db (93 + 5*2 + 7*80) & 255
	db (93 + 6*2 + 7*80) & 255
	db (93 + 7*2 + 7*80) & 255
	db (93 + 8*2 + 7*80) & 255
	db (93 + 9*2 + 7*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 8*80) & 255
	db (93 + 1*2 + 8*80) & 255
	db (93 + 2*2 + 8*80) & 255
	db (93 + 3*2 + 8*80) & 255
	db (93 + 4*2 + 8*80) & 255
	db (93 + 5*2 + 8*80) & 255
	db (93 + 6*2 + 8*80) & 255
	db (93 + 7*2 + 8*80) & 255
	db (93 + 8*2 + 8*80) & 255
	db (93 + 9*2 + 8*80) & 255
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 9*80) & 255
	db (93 + 1*2 + 9*80) & 255
	db (93 + 2*2 + 9*80) & 255
	db (93 + 3*2 + 9*80) & 255
	db (93 + 4*2 + 9*80) & 255
	db (93 + 5*2 + 9*80) & 255
	db (93 + 6*2 + 9*80) & 255
	db (93 + 7*2 + 9*80) & 255
	db (93 + 8*2 + 9*80) & 255
	db (93 + 9*2 + 9*80) & 255
	db 0,0,0,0,0,0
	
board_positions_hi
	db (93 + 0*2 + 0*80) >> 8
	db (93 + 1*2 + 0*80) >> 8
	db (93 + 2*2 + 0*80) >> 8
	db (93 + 3*2 + 0*80) >> 8
	db (93 + 4*2 + 0*80) >> 8
	db (93 + 5*2 + 0*80) >> 8
	db (93 + 6*2 + 0*80) >> 8
	db (93 + 7*2 + 0*80) >> 8
	db (93 + 8*2 + 0*80) >> 8
	db (93 + 9*2 + 0*80) >> 8 
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 1*80) >> 8
	db (93 + 1*2 + 1*80) >> 8
	db (93 + 2*2 + 1*80) >> 8
	db (93 + 3*2 + 1*80) >> 8
	db (93 + 4*2 + 1*80) >> 8
	db (93 + 5*2 + 1*80) >> 8
	db (93 + 6*2 + 1*80) >> 8
	db (93 + 7*2 + 1*80) >> 8
	db (93 + 8*2 + 1*80) >> 8
	db (93 + 9*2 + 1*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 2*80) >> 8
	db (93 + 1*2 + 2*80) >> 8
	db (93 + 2*2 + 2*80) >> 8
	db (93 + 3*2 + 2*80) >> 8
	db (93 + 4*2 + 2*80) >> 8
	db (93 + 5*2 + 2*80) >> 8
	db (93 + 6*2 + 2*80) >> 8
	db (93 + 7*2 + 2*80) >> 8
	db (93 + 8*2 + 2*80) >> 8
	db (93 + 9*2 + 2*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 3*80) >> 8
	db (93 + 1*2 + 3*80) >> 8
	db (93 + 2*2 + 3*80) >> 8
	db (93 + 3*2 + 3*80) >> 8
	db (93 + 4*2 + 3*80) >> 8
	db (93 + 5*2 + 3*80) >> 8
	db (93 + 6*2 + 3*80) >> 8
	db (93 + 7*2 + 3*80) >> 8
	db (93 + 8*2 + 3*80) >> 8
	db (93 + 9*2 + 3*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 4*80) >> 8
	db (93 + 1*2 + 4*80) >> 8
	db (93 + 2*2 + 4*80) >> 8
	db (93 + 3*2 + 4*80) >> 8
	db (93 + 4*2 + 4*80) >> 8
	db (93 + 5*2 + 4*80) >> 8
	db (93 + 6*2 + 4*80) >> 8
	db (93 + 7*2 + 4*80) >> 8
	db (93 + 8*2 + 4*80) >> 8
	db (93 + 9*2 + 4*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 5*80) >> 8
	db (93 + 1*2 + 5*80) >> 8
	db (93 + 2*2 + 5*80) >> 8
	db (93 + 3*2 + 5*80) >> 8
	db (93 + 4*2 + 5*80) >> 8
	db (93 + 5*2 + 5*80) >> 8
	db (93 + 6*2 + 5*80) >> 8
	db (93 + 7*2 + 5*80) >> 8
	db (93 + 8*2 + 5*80) >> 8
	db (93 + 9*2 + 5*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 6*80) >> 8
	db (93 + 1*2 + 6*80) >> 8
	db (93 + 2*2 + 6*80) >> 8
	db (93 + 3*2 + 6*80) >> 8
	db (93 + 4*2 + 6*80) >> 8
	db (93 + 5*2 + 6*80) >> 8
	db (93 + 6*2 + 6*80) >> 8
	db (93 + 7*2 + 6*80) >> 8
	db (93 + 8*2 + 6*80) >> 8
	db (93 + 9*2 + 6*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 7*80) >> 8
	db (93 + 1*2 + 7*80) >> 8
	db (93 + 2*2 + 7*80) >> 8
	db (93 + 3*2 + 7*80) >> 8
	db (93 + 4*2 + 7*80) >> 8
	db (93 + 5*2 + 7*80) >> 8
	db (93 + 6*2 + 7*80) >> 8
	db (93 + 7*2 + 7*80) >> 8
	db (93 + 8*2 + 7*80) >> 8
	db (93 + 9*2 + 7*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 8*80) >> 8
	db (93 + 1*2 + 8*80) >> 8
	db (93 + 2*2 + 8*80) >> 8
	db (93 + 3*2 + 8*80) >> 8
	db (93 + 4*2 + 8*80) >> 8
	db (93 + 5*2 + 8*80) >> 8
	db (93 + 6*2 + 8*80) >> 8
	db (93 + 7*2 + 8*80) >> 8
	db (93 + 8*2 + 8*80) >> 8
	db (93 + 9*2 + 8*80) >> 8
	db 0,0,0,0,0,0
	
	db (93 + 0*2 + 9*80) >> 8
	db (93 + 1*2 + 9*80) >> 8
	db (93 + 2*2 + 9*80) >> 8
	db (93 + 3*2 + 9*80) >> 8
	db (93 + 4*2 + 9*80) >> 8
	db (93 + 5*2 + 9*80) >> 8
	db (93 + 6*2 + 9*80) >> 8
	db (93 + 7*2 + 9*80) >> 8
	db (93 + 8*2 + 9*80) >> 8
	db (93 + 9*2 + 9*80) >> 8
	db 0,0,0,0,0,0
	
piece_colors
	db $26
	db $4E,$4E
	db $4A,$4A,$4A,$4A
	db $49,$49
	db $26
	db $38,$38
	db $42,$42,$42,$42
	db $3C,$3C
	db $26

piece_type_rotation_bits
	; 0 = no rotation (nothing added)
	; 1 = 2 types (max 1 added)
	; 3 = 4 types (max 3 added)
	db 0
	db 1,$FF,3,$FF,$FF,$FF,1,$FF,0
	db 1,$FF,3,$FF,$FF,$FF,1,$FF,0
	
piece_right_limit
	db 9
	db 8, 9
	db 8, 8, 8, 8
	db 7, 9
	db 8
	db 6, 9
	db 7, 7, 7, 7
	db 5, 9
	db 7
	
piece_down_limit
	db $90
	db $90, $80
	db $80, $80, $80, $80
	db $90, $70
	db $80
	db $90, $60
	db $70, $70, $70, $70
	db $90, $50
	db $70
	
piece_starting_pos_1
	db $10
	db $10, $00
	db $00, $00, $10, $10
	db $10, $00
	db $00
	db $10, $00
	db $00, $00, $00, $00
	db $10, $00
	db $00
	
piece_starting_pos_2
	db $40
	db $40, $30
	db $30, $30, $40, $40
	db $40, $30
	db $30
	db $40, $30
	db $30, $30, $30, $30
	db $40, $20
	db $30
	
piece_starting_pos_3
	db $70
	db $70, $60
	db $60, $60, $70, $70
	db $70, $60
	db $60
	db $70, $50
	db $60, $60, $60, $60
	db $70, $50
	db $60
	
piece_score
	db 1
	db 2, 2
	db 3, 3, 3, 3
	db 3, 3
	db 4
	db 4, 4
	db 5, 5, 5, 5
	db 5, 5
	db 9
	
	align 256	
piece_type_index
	; 0	= 1x1
	; 1	= 2x1
	; 3	= small L
	; 7	= 3x1 straight
	; 9	= 2x2
	; 10	= 4x1 straight
	; 12	= big L
	; 16	= 5x1
	; 18	= 3x3
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7,9,10,12,16,18
	db 0,1,3,7				; this means the first 4 pieces have (very slightly) higher chance of being randomly picked
	
	align 256	
pieces_big
	db pc_big0 & 255
	db pc_big1 & 255
	db pc_big2 & 255
	db pc_big3 & 255
	db pc_big4 & 255
	db pc_big5 & 255
	db pc_big6 & 255
	db pc_big7 & 255
	db pc_big8 & 255
	db pc_big9 & 255
	db pc_bigA & 255
	db pc_bigB & 255
	db pc_bigC & 255
	db pc_bigD & 255
	db pc_bigE & 255
	db pc_bigF & 255
	db pc_bigG & 255
	db pc_bigH & 255
	db pc_bigI & 255
	
pc_big0	db 0, $FF				; [1] "1x1"
pc_big1	db 0,1, $FF				; [2] "2x1 H"
pc_big2	db 0,$10, $FF				; [2] "1x2 V"
pc_big3	db 1,$10,$11, $FF			; [3] "small L pointing SE"
pc_big4	db 0,$10,$11, $FF			; [3] "small L pointing SW"
pc_big5	db 0,1,$10, $FF				; [3] "small L pointing NW"
pc_big6	db 0,1,$11, $FF				; [3] "small L pointing NE"
pc_big7	db 0,1,2, $FF				; [3] "3x1 H"
pc_big8	db 0,$10,$20, $FF			; [3] "1x3 V"
pc_big9	db 0,1,$10,$11, $FF			; [4] "2x2"
pc_bigA	db 0,1,2,3, $FF				; [4] "4x1 H"
pc_bigB	db 0,$10,$20,$30, $FF			; [4] "1x4 V"
pc_bigC	db 2,$12,$20,$21,$22, $FF		; [5] "big L pointing SE"
pc_bigD	db 0,$10,$20,$21,$22, $FF		; [5] "big L pointing SW"
pc_bigE	db 0,1,2,$10,$20, $FF			; [5] "big L pointing NW"
pc_bigF	db 0,1,2,$12,$22, $FF			; [5] "big L pointing NE"
pc_bigG db 0,1,2,3,4, $FF			; [5] "5x1 H"
pc_bigH	db 0,$10,$20,$30,$40, $FF		; [5] "1x5 V"
pc_bigI	db 0,1,2,$10,$11,$12,$20,$21,$22, $FF	; [9] "3x3"

pieces_small
	db pc_sml0 - pieces_small
	db pc_sml1 - pieces_small
	db pc_sml2 - pieces_small
	db pc_sml3 - pieces_small
	db pc_sml4 - pieces_small
	db pc_sml5 - pieces_small
	db pc_sml6 - pieces_small
	db pc_sml7 - pieces_small
	db pc_sml8 - pieces_small
	db pc_sml9 - pieces_small
	db pc_smlA - pieces_small
	db pc_smlB - pieces_small
	db pc_smlC - pieces_small
	db pc_smlD - pieces_small
	db pc_smlE - pieces_small
	db pc_smlF - pieces_small
	db pc_smlG - pieces_small
	db pc_smlH - pieces_small
	db pc_smlI - pieces_small
	
pc_sml0	db 82, $FF				; [1] "1x1"
pc_sml1	db 81,82, $FF				; [2] "2x1 H"
pc_sml2	db 42,82, $FF				; [2] "1x2 V"
pc_sml3	db 42,81,82, $FF			; [3] "small L pointing SE"
pc_sml4	db 42,82,83, $FF			; [3] "small L pointing SW"
pc_sml5	db 82,83,122, $FF			; [3] "small L pointing NW"
pc_sml6	db 81,82,122, $FF			; [3] "small L pointing NE"
pc_sml7	db 81,82,83, $FF			; [3] "1x3 H"
pc_sml8	db 42,82,122, $FF			; [3] "3x1 V"
pc_sml9	db 41,42,81,82, $FF			; [4] "2x2"
pc_smlA	db 81,82,83,84, $FF			; [4] "1x4 H"
pc_smlB	db 2,42,82,122, $FF			; [4] "4x1 V"
pc_smlC	db 43,83,121,122,123, $FF		; [5] "sml L pointing SE"
pc_smlD	db 41,81,121,122,123, $FF		; [5] "sml L pointing SW"
pc_smlE	db 41,42,43,81,121, $FF			; [5] "sml L pointing NW"
pc_smlF	db 41,42,43,83,123, $FF			; [5] "sml L pointing NE"
pc_smlG	db 80,81,82,83,84, $FF			; [5] "1x5 H"
pc_smlH	db 2,42,82,122,162, $FF			; [5] "5x1 V"
pc_smlI	db 41,42,43,81,82,83,121,122,123, $FF	; [9] "3x3"

;eof